''
'' Spread sheet example
''

#Include Once "windows.bi"
#Include Once "win/shellapi.bi"

#Include "SprShtDemo.bi"
#Include "..\..\..\Inc\SpreadSheet.bi"

Dim Shared hInst As HMODULE
Dim Shared hWnd As HWND
Dim Shared hSpr As HWND
Dim hLib As HMODULE
Dim msg As MSG


Sub Grid_Setup(ByVal hDlg As HWND)
	Dim gfmt As GLOBAL
	Dim spri As SPR_ITEM
	Dim nnum As Integer
	Dim d As Double
	Dim s As Single
   Dim fnt As FONT
   Dim chk As CHECK
   Dim cbo As COMBO

	' Get the handle of spreadsheet control
	hSpr=GetDlgItem(hDlg,IDC_SPR1)
	' Set number of rows and cols
	SendMessage(hSpr,SPRM_SETROWCOUNT,5,0)
	SendMessage(hSpr,SPRM_SETCOLCOUNT,2,0)
	' Create a font
   fnt.face="Courier New"
   fnt.fsize=19
   fnt.ht=-25
   SendMessage(hSpr,SPRM_SETFONT,1,Cast(LPARAM,VarPtr(fnt)))
	' Set column header text
	spri.flag=SPRIF_TEXTALIGN Or SPRIF_DATA Or SPRIF_WIDTH Or SPRIF_HEIGHT
	spri.col=1
	spri.row=0
	spri.fmt.txtal=FMTA_CENTER Or FMTA_MIDDLE
	spri.wt=200
	spri.ht=25
	spri.lpdta=StrPtr(" Col1 ")
	SendMessage(hSpr,SPRM_SETCELLDATA,0,Cast(LPARAM,VarPtr(spri)))
	' Convert a single to  extended double (80 bit)
	s=23.45
	spri.flag=SPRIF_DATA Or SPRIF_TYPE Or SPRIF_SINGLE
	spri.col=2
	spri.row=1
	spri.fmt.tpe=TPE_FLOAT
	spri.lpdta=VarPtr(s)
	SendMessage(hSpr,SPRM_SETCELLDATA,0,Cast(LPARAM,VarPtr(spri)))
	' Convert a double to extended double (80 bit)
	d=1.23
	spri.flag=SPRIF_DATA Or SPRIF_TYPE Or SPRIF_DOUBLE
	spri.col=1
	spri.row=1
	spri.fmt.tpe=TPE_FLOAT
	spri.lpdta=VarPtr(d)
	SendMessage(hSpr,SPRM_SETCELLDATA,0,Cast(LPARAM,VarPtr(spri)))
	' Create a button cell
	spri.flag=SPRIF_TEXTALIGN Or SPRIF_DATA Or SPRIF_TYPE
	spri.col=1
	spri.row=2
	spri.fmt.txtal=FMTA_LEFT Or FMTA_MIDDLE
	spri.fmt.tpe=TPE_BUTTON Or TPE_TEXT
	spri.lpdta=StrPtr("Hello")
	SendMessage(hSpr,SPRM_SETCELLDATA,0,Cast(LPARAM,VarPtr(spri)))
	' Create hyperlink cell
	spri.flag=SPRIF_STATE Or SPRIF_TEXTALIGN Or SPRIF_DATA Or SPRIF_TYPE Or SPRIF_HEIGHT
	spri.col=1
	spri.row=3
	spri.ht=50
	spri.state=STATE_LOCKED
	spri.fmt.txtal=FMTA_CENTER Or FMTA_MIDDLE
	spri.fmt.tpe=TPE_HYPERLINK
	spri.lpdta=StrPtr("http://fbedit.freebasic.net/")
	SendMessage(hSpr,SPRM_SETCELLDATA,0,Cast(LPARAM,VarPtr(spri)))
	' Create an ownerdraw integer cell, used here to display an icon
	nnum=1
	spri.flag=SPRIF_STATE Or SPRIF_DATA Or SPRIF_TYPE Or SPRIF_HEIGHT
	spri.col=2
	spri.row=3
	spri.ht=50
	spri.state=STATE_LOCKED
	spri.fmt.tpe=TPE_OWNERDRAWINTEGER
	spri.lpdta=VarPtr(nnum)
	SendMessage(hSpr,SPRM_SETCELLDATA,0,Cast(LPARAM,VarPtr(spri)))
	' Create hyperlink cell, uses the new font
	spri.flag=SPRIF_STATE Or SPRIF_TEXTALIGN Or SPRIF_DATA Or SPRIF_TYPE Or SPRIF_HEIGHT Or SPRIF_FONT
	spri.col=1
	spri.row=4
	spri.ht=50
	spri.state=STATE_LOCKED
	spri.fmt.txtal=FMTA_CENTER Or FMTA_MIDDLE
	spri.fmt.fnt=1
	spri.fmt.tpe=TPE_HYPERLINK
	spri.lpdta=StrPtr("http://www.radasm.com/")
	SendMessage(hSpr,SPRM_SETCELLDATA,0,Cast(LPARAM,VarPtr(spri)))
	' Create an ownerdraw integer cell, used here to display an icon
	nnum=2
	spri.flag=SPRIF_STATE Or SPRIF_DATA Or SPRIF_TYPE Or SPRIF_HEIGHT
	spri.col=2
	spri.row=4
	spri.ht=50
	spri.state=STATE_LOCKED
	spri.fmt.txtal=FMTA_RIGHT Or FMTA_MIDDLE
	spri.fmt.tpe=TPE_OWNERDRAWINTEGER
	spri.lpdta=VarPtr(nnum)
	SendMessage(hSpr,SPRM_SETCELLDATA,0,Cast(LPARAM,VarPtr(spri)))
	' Create a checbox cell, checked
	spri.flag=SPRIF_TEXTALIGN Or SPRIF_IMAGEALIGN Or SPRIF_DATA Or SPRIF_TYPE
	spri.col=1
	spri.row=5
	spri.fmt.txtal=FMTA_LEFT Or FMTA_MIDDLE
	spri.fmt.imgal=FMTA_LEFT Or FMTA_MIDDLE
	spri.fmt.tpe=TPE_CHECKBOX Or TPE_FIXEDSIZE
	chk.checked=1
	chk.text="CheckBox"
	spri.lpdta=VarPtr(chk)
	SendMessage(hSpr,SPRM_SETCELLDATA,0,Cast(LPARAM,VarPtr(spri)))
	' Create a combobox cell
	' Create the ComboBox
	cbo.hwnd=SendMessage(hSpr,SPRM_CREATECOMBO,80,0)
	' Set ComboBox font
	SendMessage(cbo.hwnd,WM_SETFONT,SendMessage(hDlg,WM_GETFONT,0,0),FALSE)
	' Put some text into combo
	SendMessage(cbo.hwnd,LB_ADDSTRING,0,Cast(LPARAM,StrPtr("Test 1")))
	SendMessage(cbo.hwnd,LB_ADDSTRING,0,Cast(LPARAM,StrPtr("Test 2")))
	' Set the selected index
	cbo.index=1
	spri.flag=SPRIF_TEXTALIGN Or SPRIF_IMAGEALIGN Or SPRIF_DATA Or SPRIF_TYPE
	spri.col=2
	spri.row=5
	spri.fmt.txtal=FMTA_LEFT Or FMTA_MIDDLE
	spri.fmt.imgal=FMTA_RIGHT Or FMTA_MIDDLE
	spri.fmt.tpe=TPE_COMBOBOX Or TPE_FIXEDSIZE
	spri.lpdta=VarPtr(cbo)
	SendMessage(hSpr,SPRM_SETCELLDATA,0,Cast(LPARAM,VarPtr(spri)))

End Sub

''' Start DlgProc
Function DlgProc(ByVal hDlg As HWND, ByVal uMsg As UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM) As Integer
	Dim rect As RECT
	Dim lpDRAWITEMSTRUCT As DRAWITEMSTRUCT Ptr
	Dim hIcon As HICON
	Dim lpSPR_ITEM As SPR_ITEM Ptr
	Dim lpNMHDR As NMHDR Ptr
	Dim lpSPR_HYPERLINK As SPR_HYPERLINK Ptr
	Dim lpSPR_BUTTON As SPR_BUTTON Ptr
	Dim spri As SPR_ITEM

	Select Case uMsg
		Case WM_INITDIALOG
			Grid_Setup(hDlg)
			'
		Case WM_COMMAND
			Select Case LoWord(wParam)
				Case IDC_BTN1
					' Test converting from integer or extended double (80 bit) to double
					spri.flag=SPRIF_DOUBLE
					spri.col=1
					spri.row=1
					SendMessage(hSpr,SPRM_GETCELLDATA,0,Cast(LPARAM,VarPtr(spri)))
					MessageBox(hDlg,Str(*Cast(Double Ptr,spri.lpdta)),"Double",MB_OK)
					' Test converting from integer or extended double (80 bit) to single
					spri.flag=SPRIF_SINGLE
					spri.col=2
					spri.row=1
					SendMessage(hSpr,SPRM_GETCELLDATA,0,Cast(LPARAM,VarPtr(spri)))
					MessageBox(hDlg,Str(*Cast(Single Ptr,spri.lpdta)),"Single",MB_OK)
					'
			End Select
		Case WM_CLOSE
			DestroyWindow(hDlg)
			'
		Case WM_DESTROY
			PostQuitMessage(0)
			'
		Case WM_SIZE
			GetClientRect(hDlg,VarPtr(rect))
			MoveWindow(hSpr,rect.left,rect.top,rect.right,rect.bottom-40,TRUE)
			MoveWindow(GetDlgItem(hDlg,IDC_BTN1),rect.right-100,rect.bottom-35,90,30,TRUE)
			'
		Case WM_DRAWITEM
			' Get a pointer to the DRAWITEMSTRUCT
			lpDRAWITEMSTRUCT=Cast(DRAWITEMSTRUCT Ptr,lParam)
			' Center the icon in the cell
			lpDRAWITEMSTRUCT->rcItem.left=lpDRAWITEMSTRUCT->rcItem.left+(lpDRAWITEMSTRUCT->rcItem.right-lpDRAWITEMSTRUCT->rcItem.left-32)/2
			lpDRAWITEMSTRUCT->rcItem.top=lpDRAWITEMSTRUCT->rcItem.top+(lpDRAWITEMSTRUCT->rcItem.bottom-lpDRAWITEMSTRUCT->rcItem.top-32)/2
			' Get a pointer to the SPR_ITEM
			lpSPR_ITEM=Cast(SPR_ITEM Ptr,lpDRAWITEMSTRUCT->itemData)
			' Load the icon. The icon ID is the cells integer value.
			hIcon=LoadIcon(hInst,Cast(ZString Ptr,*Cast(Integer Ptr,lpSPR_ITEM->lpdta)))
			' Draw the icon
			DrawIcon(lpDRAWITEMSTRUCT->hdc,lpDRAWITEMSTRUCT->rcItem.left,lpDRAWITEMSTRUCT->rcItem.top,hIcon)
			'
		Case WM_NOTIFY
			lpNMHDR=Cast(NMHDR Ptr,lParam)
			' Check if notification is from the spread sheet control
			If lpNMHDR->hwndFrom=hSpr Then
				Select Case lpNMHDR->code
					Case SPRN_HYPERLINKCLICK
						' Get a pointer to the SPR_HYPERLINK
						lpSPR_HYPERLINK=Cast(SPR_HYPERLINK Ptr,lParam)
						' Get a pointer to the SPR_ITEM.
						lpSPR_ITEM=lpSPR_HYPERLINK->lpspri
						' Let windows open the link.
						ShellExecute(hDlg,StrPtr("Open"),Cast(ZString Ptr,lpSPR_ITEM->lpdta),NULL,NULL,SW_SHOWDEFAULT)
					Case SPRN_BUTTONCLICK
						' Get a pointer to the SPR_BUTTON
						lpSPR_BUTTON=Cast(SPR_BUTTON Ptr,lParam)
						' Get a pointer to the SPR_ITEM.
						lpSPR_ITEM=lpSPR_BUTTON->lpspri
						MessageBox(hDlg,"Row: " & Str(lpSPR_ITEM->row) & Chr(13) & Chr(10) & "Col: " & Str(lpSPR_ITEM->col),"Button click",MB_OK)
				End Select
			EndIf
			'
		Case Else
			Return FALSE
			'
	End Select
	Return TRUE

End Function

''' end DlgProc


'''
''' Program start
'''

hInst=GetModuleHandle(NULL)

hLib=LoadLibrary("SprSht.dll")

If hLib Then
	'' Create the Dialog
	hWnd=CreateDialogParam(hInst,Cast(ZString Ptr,IDD_DLG1), NULL, Procptr(DlgProc), NULL)
	Do While GetMessage(VarPtr(msg),NULL,0,0)
		TranslateMessage(VarPtr(msg))
		DispatchMessage(VarPtr(msg))
	Loop
Else
	MessageBox(NULL,StrPtr("Could not find sprsht.dll"),StrPtr("SpreadSheet control"),MB_OK Or MB_ICONERROR)
EndIf


''
'' Program has ended
''
ExitProcess(0)
End

'''
''' Program end
'''
